package shell.progressBar;

public class ProgressBar implements IProgressBar {
	private IProgressBar progBar = null;
	boolean isDeterminate = true;
	
	public ProgressBar(boolean isDeterminate) {
		setDeterminate(isDeterminate);
	}
	
	public ProgressBar() {
		this(true);
	}
	
	public final boolean isDeterminate() {
		return isDeterminate;
	}
	
	public final void setDeterminate(boolean isDeterminate){
		if (this.isDeterminate == isDeterminate && progBar != null) return;
		
		if (isDeterminate)
			progBar = new DeterminateProgressBar();
		else
			progBar = new UndeterminateProgressBar();
		this.isDeterminate = isDeterminate;
	}
	
	public void setValue(int value) {
		if(value < 0)
			value = 0;
		else if (value > 100)
			value = 100;
		progBar.setValue(value);
	}

	public int getValue() {
		return progBar.getValue();
	}
	
	public boolean isVisible() {
		return progBar.isVisible();
	}

	public void setVisible(boolean visible) {
		progBar.setVisible(visible);
	}

	@Override
	public void setWidth(int width) {
		progBar.setWidth(width);
	}

	@Override
	public int getWidth() {
		return progBar.getWidth();
	}
	
}
